from spaceone.api.monitoring.v1 import metric_pb2
from spaceone.core.pygrpc.message_type import *

__all__ = ['MetricsInfo', 'MetricDataInfo']


def MetricDataInfo(metric_data):
    info = {
        'labels': change_list_value_type(metric_data['labels']),
        'resource_values': change_struct_type(metric_data['resource_values']),
        'domain_id': metric_data['domain_id']
    }

    return metric_pb2.MetricDataInfo(**info)


def MetricInfo(metric):
    info = {
        'key': metric['key'],
        'name': metric['name'],
        'unit': change_struct_type(metric['unit']),
        'chart_type': metric['chart_type'],
        'chart_option': change_struct_type(metric.get('chart_option', {}))
    }

    return metric_pb2.MetricInfo(**info)


def MetricsInfo(metrics):
    info = {
        'metrics': list(map(MetricInfo, metrics['metrics'])),
        'available_resources': change_struct_type(metrics['available_resources']),
        'domain_id': metrics['domain_id']
    }

    return metric_pb2.MetricsInfo(**info)
